Subject: Re: bug#66117: 30.0.50; `find-buffer-visiting' is slow when opening large number of buffers

From: Ihor Radchenko <[email-masked]>
Date: Wed, 13 Dec 2023 13:43:23 +0000

Eli Zaretskii <[email-masked]> writes:

>> AFAIU, it is very hard to rewrite them in C, as I explained in
>> https://debbugs.gnu.org/cgi/bugreport.cgi?bug=66117#157
>
> The only explanation I see there is that they "recursively call
> other Elisp functions".  Is there any other reason?

The main problem I see is that `abbreviate-file-name' uses a number of
variables, including customizations, defined in ELisp. I suspect that
moving all of those to Elisp will neither be easy nor practical.

> My point is that by trying to speed-up let-binding of case-fold-search
> and similar variables you are trying to solve a much more general
> problem, and a much harder one at that.  IME, if an idea for a
> solution leads to a more general and harder-to-solve problem than the
> original, then the idea should be dropped, and one should look for
> alternative ideas.

The simplest solution would be what `ido-make-buffer-list-1' does:

    ;; Each call to ido-ignore-item-p LET-binds case-fold-search.
    ;; That is slow if there's no buffer-local binding available,
    ;; roughly O(number of buffers).  This hack avoids it.
    (setq-local case-fold-search nil)

But it will only solve specific problem with `find-buffer-visiting' and
we can always go for it if we cannot find anything better.

I thought that trying to solve a more general problem would benefit more
code - let-binding case-fold-search is extremely common across packages.

-- 
Ihor Radchenko // yantar92,
Org mode contributor,
Learn more about Org mode at <https://orgmode.org/>.
Support Org development at <https://liberapay.com/org-mode>,
or support my work at <https://liberapay.com/yantar92>